\definecolor{vertex_fill}{RGB}{125,125,125}

\usetikzlibrary{arrows, positioning, calc, shapes, decorations.markings,
decorations.pathreplacing, math}

\tikzset{Gap/.style={regular polygon, regular polygon sides=3, rotate=0,
            thick, minimum size=0.3cm, draw=vertex_fill, fill=vertex_fill,
            inner sep = -0.1, anchor=south}}
\tikzset{Sigma/.style={circle, thick, minimum size=0.4cm, draw=vertex_fill,
            fill=vertex_fill, inner sep = -0.1}}
\tikzset{Vertex/.style={regular polygon, regular polygon sides=4, thick,
            minimum size=0.4cm, draw=vertex_fill, fill=vertex_fill,
            inner sep = -0.1}}
\tikzset{GammaSix/.style={regular polygon, regular polygon sides=6, rotate=30,
            thick, minimum size=0.4cm, draw=vertex_fill, fill=vertex_fill,
            inner sep = -0.1}}

\tikzset{Propagator/.style=thick}
\tikzset{Fermion/.style={Propagator,postaction={decorate,
        decoration={markings, mark=at position .8
            with {\arrow[black,scale=0.65]{latex}}}}}}
\tikzset{FermionBend/.style={Propagator,postaction={decorate,
        decoration={markings, mark=at position .5
            with {\arrow[black,scale=0.65]{latex reversed}}}}}}
\tikzset{FermionBend2/.style={Propagator,postaction={decorate,
        decoration={markings, mark=at position .4
            with {\arrow[black,scale=0.65]{latex reversed}}}}}}
\tikzset{FermionBend3/.style={Propagator,postaction={decorate,
        decoration={markings, mark=at position .6
            with {\arrow[black,scale=0.65]{latex reversed}}}}}}
\tikzset{Interaction/.style={Propagator,decorate, decoration=snake}}

\begin{tikzpicture}[x=0.6cm, y=0.6cm, label distance= -0.35cm]
        % Derivative
        \node[] at (-1.5,0) {$\displaystyle\frac{\mathrm{d}}{\mathrm{d}\Lambda}$};
        % Gamma eff
        \begin{scope}[shift={(0,0)}]
            \node[Vertex, fill=vertex_fill] (gamma_eff) at (0,0) {};
            \node[] (k0_eff) at (-1,1){};
            \node[] (k1_eff) at (-1,-1){};
            \node[] (k2_eff) at (1,1){};
            \node[] (k3_eff) at (1,-1){};
            \draw[Fermion] (k0_eff) -- (gamma_eff);
            \draw[Fermion] (k1_eff) -- (gamma_eff);
            \draw[Fermion] (gamma_eff) -- (k2_eff);
            \draw[Fermion] (gamma_eff) -- (k3_eff);
            \end{scope}
        % equals
        \node[] at (1.75,0) {$=$};
        % P-Channel
        \begin{scope}[shift={(3.0,0)}]
            %\node[draw=p-channel, minimum width=1.75cm, minimum height=1cm, line width=1pt]
            %    at (0.75,0) {};
            \node[Vertex] (gamma_P) at (0,0) {};
            \node[Vertex] (gamma_P2) at (1.5,0) {};
            \node[] (k0_P) at (-1,1){};
            \node[] (k1_P) at (-1,-1){};
            \node[] (k2_P) at (2.5,1){};
            \node[] (k3_P) at (2.5,-1){};
            \draw[Fermion] (k0_P) -- (gamma_P);
            \draw[Fermion] (k1_P) -- (gamma_P);
            \draw[Fermion] (gamma_P2) -- (k2_P);
            \draw[Fermion] (gamma_P2) -- (k3_P);
            \draw[bend right=40, FermionBend] (gamma_P2.north west)
                to (gamma_P.north east);
            \draw[bend left=40, FermionBend] (gamma_P2.south west)
                to (gamma_P.south east);
            \draw[Propagator] (0.3,-0.7) -- (1.2,0.7);
        \end{scope}
        % Plus
        \node[] at (5.75,0) {$+$};
        % D-Channel
        \begin{scope}[shift={(7,0)}]
            %\node[draw=d-channel, minimum width=1cm, minimum height=1.75cm, line width=1pt]
            %    at (0,0) {};
            \node[Vertex] (gamma_D) at (0,0.75) {};
            \node[Vertex] (gamma_D2) at (0,-0.75) {};
            \node[] (k0_D) at (-1,1.75){};
            \node[] (k2_D) at (1,1.75){};
            \node[] (k1_D) at (-1,-1.75){};
            \node[] (k3_D) at (1,-1.75){};
            \draw[Fermion] (k0_D) -- (gamma_D);
            \draw[Fermion] (gamma_D) -- (k2_D);
            \draw[Fermion] (k1_D) -- (gamma_D2);
            \draw[Fermion] (gamma_D2) -- (k3_D);
            \draw[bend right=40, FermionBend] (gamma_D.south west)
                to (gamma_D2.north west);
            \draw[bend right=40, FermionBend] (gamma_D2.north east)
                to (gamma_D.south east);
            \draw[Propagator] (-0.7,0.45) -- (0.7,-0.45);
        \end{scope}
        % Plus
        \node[] at (8.25,0) {$+$};
        % C-Channel
        \begin{scope}[shift={(9.5,0)}]
            %\node[draw=c-channel, minimum width=1.5cm, minimum height=1.75cm, line width=1pt]
            %    at (0.5,0) {};
            \node[Vertex] (gamma_C) at (0,0.75) {};
            \node[Vertex] (gamma_C2) at (0,-0.75) {};
            \node[] (k0_C) at (-1,1.75){};
            \node[] (k2_C) at (2,1.75){};
            \node[] (k1_C) at (-1,-1.75){};
            \node[] (k3_C) at (2,-1.75){};
            \draw[Fermion] (k0_C) -- (gamma_C);
            \draw[Fermion] (k1_C) -- (gamma_C2);
            \draw[bend right=40, Propagator] (gamma_C2.south east)
                to ($(gamma_C2.south east)+(0.3,0)$);
            \draw[Fermion] ($(gamma_C2.south east)+(0.3,0)$) -- (k2_C);
            \draw[bend left=40,Propagator] (gamma_C.north east)
                to ($(gamma_C.north east) + (0.3,0)$);
            \draw[Fermion] ($(gamma_C.north east) + (0.3,0)$) -- (k3_C);
            \draw[bend right=40, FermionBend] (gamma_C.south west)
                to (gamma_C2.north west);
            \draw[bend right=40, FermionBend] (gamma_C2.north east)
                to (gamma_C.south east);
            \draw[Propagator] (-0.7,0.45) -- (0.7,-0.45);
            \node[] at (2.5,-0.5){.};
        \end{scope}
        %\begin{scope}[shift={(0,-5)}]
        % Insert SU2 here if needed
        %\end{scope}
\end{tikzpicture}
